﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management.Automation.Host;

namespace Evaluant.PS4VS.Renderer
{
    class VSHostUI : PSHostUserInterface
    {
        MyToolWindow window;
        PSHostRawUserInterface rawUI;

        public VSHostUI(MyToolWindow window)
        {
            this.window = window;
            rawUI = new VSHostRawUI(window);
        }

        public override Dictionary<string, System.Management.Automation.PSObject> Prompt(string caption, string message, System.Collections.ObjectModel.Collection<FieldDescription> descriptions)
        {
            throw new NotImplementedException();
        }

        public override int PromptForChoice(string caption, string message, System.Collections.ObjectModel.Collection<ChoiceDescription> choices, int defaultChoice)
        {
            throw new NotImplementedException();
        }

        public override System.Management.Automation.PSCredential PromptForCredential(string caption, string message, string userName, string targetName, System.Management.Automation.PSCredentialTypes allowedCredentialTypes, System.Management.Automation.PSCredentialUIOptions options)
        {
            throw new NotImplementedException();
        }

        public override System.Management.Automation.PSCredential PromptForCredential(string caption, string message, string userName, string targetName)
        {
            throw new NotImplementedException();
        }

        public override PSHostRawUserInterface RawUI
        {
            get { return rawUI; }
        }

        public override string ReadLine()
        {
            return window.ReadLine();
        }

        public override System.Security.SecureString ReadLineAsSecureString()
        {
            throw new NotImplementedException();
        }

        public override void Write(ConsoleColor foregroundColor, ConsoleColor backgroundColor, string value)
        {
            window.Write(foregroundColor, backgroundColor, value);
        }

        public override void Write(string value)
        {
            window.Write(rawUI.ForegroundColor, rawUI.BackgroundColor, value);
        }

        public override void WriteDebugLine(string message)
        {
            window.WriteLine(rawUI.ForegroundColor, rawUI.BackgroundColor, message);
        }

        public override void WriteErrorLine(string value)
        {
            window.WriteLine(rawUI.ForegroundColor, rawUI.BackgroundColor, value);
        }

        public override void WriteLine(string value)
        {
            window.WriteLine(rawUI.ForegroundColor, rawUI.BackgroundColor, value);
        }

        public override void WriteProgress(long sourceId, System.Management.Automation.ProgressRecord record)
        {
            throw new NotImplementedException();
        }

        public override void WriteVerboseLine(string message)
        {
            window.WriteLine(rawUI.ForegroundColor, rawUI.BackgroundColor, message);
        }

        public override void WriteWarningLine(string message)
        {
            window.WriteLine(rawUI.ForegroundColor, rawUI.BackgroundColor, message);
        }
    }
}
